/**
 * A example program illustrating a cached thread pool
 *
 * Figure 5.20
 *
 * @author Gagne, Galvin, Silberschatz
 * Operating System Concepts with Java - Eighth Edition
 * Copyright John Wiley & Sons - 2010.
 * 
 * Modified F. Green, 2/4/2013
 * Incorporates labelled tasks, and less sleep time.
 */

import java.util.concurrent.*;

public class TPExample
{
	public static void main(String[] args) {
		int numTasks = Integer.parseInt(args[0].trim());
		
		// create the thread pool
		ExecutorService pool = java.util.concurrent.Executors.newCachedThreadPool();

		// run each task using a thread in the pool
		for (int i = 0; i < numTasks; i++)
			pool.execute(new Task(i));
		
		// sleep for 0.1 seconds
		try { Thread.sleep(1000); } catch (InterruptedException ie) { }

		pool.shutdown();
	}
}


class Task implements Runnable
{
    private int taskID;
    public Task (int n)
    {
        taskID = n;
    }
	public void run() {
		System.out.println(taskID + " is working on a task.");
	}
}
